----------------------------------------------------------------------------------------------------------
------------------------------------------------MageGate------------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Written by: Endar_Ren																				--
----------------------------------------------------------------------------------------------------------
----------------------------------------------Change History----------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Version 1.1 Changes 8/25/2010																		--
-- *  Fixed use of addon when a target or a group member is casting a portal.							--
-- *  Corrected GateGroup function so that the Party channel is used outside of an instance.			--
-- *  Corrected spelling error:  "Dailing".																--
--======================================================================================================--							
-- Version 1.2 Changes 10/5/10																			--
-- *  Fixed the nothing happening in Party group type. (I think)										--
--======================================================================================================--
-- Version 1.3 Changes 10/13/2010																		--
-- *  Now usable in 4.0.1.																				--
--======================================================================================================--
-- Version 1.4 Changes 11/3/2010																		--
-- *  Add in Slash Command to turn the addon on and off. (Does not disable or enable the addon)			--
--======================================================================================================--
-- Version 1.4.1 Changes 11/18/2010																		--
-- *  Added Confirm Summons event and "Incoming traveller" message.  Need to test.	FAILED				--
-- *  Changed GateGroup to use number in the party to see if you are alone.	Need to test.  FAILED		--
-- *  Added version number field.																		--
--======================================================================================================--
-- Version 1.4.2  Changed 1/3/2011																		--
-- * Adding in sound effects.  Sounds given to me by Ricardo58.  Thank you.								--
--======================================================================================================--
-- Version 1.4.3 Changed 4/26/2011																		--
-- * TOC version number changed to 40100.																--
--======================================================================================================--
-- Version 2 Changed 7/1/2011																			--
-- * TOC version number changed to 40200.																--
-- * Ace3 Library implemented.																			--
-- * New Slash commands:  sfx & autosum.																--
-- * New Sound Effect for summon																		--
-- * Stargate Atlantis Dialing abort sound effect option added.											--
--======================================================================================================--

MageGate = LibStub("AceAddon-3.0"):NewAddon("MageGate","AceConsole-3.0","AceComm-3.0", "AceEvent-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local MG_VERSION = 20000;
channeling =false;
NeooptionTable = {
		name = "MageGate",
		handler = MageGate,
		type = 'group',
		args = {

				sfx =   {
									name="Sound Effects",
									desc = "Turns sound effects on and off.",
									type = "execute",
									func ="SoundEffects"
						},
				autosum  =   {
									name="Auto Summon",
									desc = "Turns auto-accept for summon on or off.",
									type = "execute",
									func ="AutoSummon"
						},
				abortfx  =   {
									name="Abort Effect",
									desc = "Changes the portal cancel sound effect.  Choices are sg1 and sga",
									type = "toggle",
									set ="ChangeAbortSFX",
									get=function () return AUTOSUMM end
						}
				
				}
			}

LibStub("AceConfig-3.0"):RegisterOptionsTable("MageGate", NeooptionTable, {"mgate"})
function MageGate:OnInitialize()
	if GATEON == nil then
		GATEON = true;
	end
	if SOUNDFX == nil then
		SOUNDFX = true
	end
	if AUTOSUMM == nil then
		AUTOSUMM = true;
	end
	if ABORTSTY == nil then
		ABORTSTY = "sg1"
	end
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED") 
	self:RegisterEvent("CONFIRM_SUMMON")
end


function MageGate:OnEnabled()

	
end

function MageGate:OnDisable()

end

function MageGate:AutoSummon(info, val)
	AUTOSUMM = AUTOSUMM == false;
	if AUTOSUMM then
		print("Auto Summon Accept is on.")
	else
		print("Auto Summon Accept is off.")
	end
end
function MageGate:ChangeAbortSFX(info, val)
	if string.len(val) == 3 then
		if string.find("sg1",val) == nil then
			ABORTSTY = "sga"
		
		else
			ABORTSTY = "sg1"
		end
	else
		print("Invalid input.  Enter either 'sg1' or 'sga'")
	end

end
function MageGate:UNIT_SPELLCAST_START(eveName, unitID, spell,...)
	local beg, last = string.find(spell,"Portal: ");
	if (beg~=nil) then
		if (unitID == "player") then
			local chann = self:GateGroup();
			channeling = true;
			SendChatMessage("Dialing ".. string.sub(spell,last+1) ..".", chann);
		end
	end
end
function MageGate:UNIT_SPELLCAST_STOP(eveName, unitID, spell,...)
--print ("pots")
end
function MageGate:UNIT_SPELLCAST_SUCCEEDED(eveName, unitID, spell,...)
--print ("succ")
	local beg, last = string.find(spell,"Portal: ");
	if (beg~=nil) then
		if (unitID == "player") then
			local chann = self:GateGroup();
			channeling = false;
			SendChatMessage("Chevron 7 locked!", chann);

		end
		if SOUNDFX then
			PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Kawoosh 1.ogg")
		end
	end

end
function MageGate:UNIT_SPELLCAST_INTERRUPTED(eveName, unitID, spell,...)
if channeling then
	local beg, last = string.find(spell,"Portal: ");
	if (beg~=nil) then
		if (unitID == "player") then
			local chann = self:GateGroup();
			channeling = false;
			SendChatMessage("Dialing sequence aborted!", chann);

		end
		if SOUNDFX then
			if string.find("sg1",ABORTSTY) ~= nil  then 
				PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
			else
			--Atlantis Dial Abort
				PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg")
			end
		end
	end
	end
end
function MageGate:UNIT_SPELLCAST_FAILED_QUIET(eveName, unitID, spell,...)
if channeling then
	local beg, last = string.find(spell,"Portal: ");
	if (beg~=nil) then
		if (unitID == "player") then
			local chann = self:GateGroup();
			channeling = false;
			SendChatMessage("Dialing sequence aborted!", chann);

		end
		if SOUNDFX then
			if string.find("sg1",ABORTSTY) ~= nil  then 
				PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
			else
			--Atlantis Dial Abort
				PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg")
			end
		end
	end
	end
end
function MageGate:CONFIRM_SUMMON(eveName, ...)
	--Special thanks to Garshaw of Mok`Nathal for this idea.
	if AUTOSUMM == true then
		local chann = self.GateGroup();
		SendChatMessage("Incoming traveller!", chann);
		ConfirmSummon()
		if SOUNDFX == true then
			PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg")
		end

	end
end

function MageGate:SoundEffects(info,val)
	SOUNDFX = SOUNDFX == false;
	if SOUNDFX then
		print("Sound effects are on")
	else
		print("Sound effects are off")
	end
end

--This function is used to determine which kind of group,
--if any, the player is in.  It returns the channel name
--needed to reach all the players in that group.
--The return value is a String.

function MageGate:GateGroup ()
	if GetNumPartyMembers()>0 then
		if (UnitInParty("player") ~= nil) then
			if (UnitInRaid("player") ~= nil) then
				return "RAID"
			end
			return "PARTY"
		end
	else
		if (UnitInRaid("player") ~= nil) then
				return "RAID"
		else
			return "SAY"
		end
	end
end